#include <stdio.h>
#include <math.h>
#include <string.h>
#define MAX 100010

int n, poleX[MAX], poleY[MAX], delkaH[MAX], delkaV[MAX];
/* 1=SMER Horizont - 
 * 0=SMER VERT | */
int recurseV(int bod);
int recurseH(int bod) {
	int i, max=-1, min=-1, maxc=-1, minc=-1;
	if (delkaH[bod]==-1) {
		for (i=0;i<n;i++) {
			if ((poleX[i]==poleX[bod])&&(i!=bod)) {
				if (poleY[i]<poleY[bod]) {
					if (min==-1) {
						min=i;
					} else {
						if (poleY[i]>poleY[min]) {
							min=i;
						}
					}
				} else {
					if (max==-1) {
						max=i;
					} else {
						if (poleY[i]<poleY[max]) {
							max=i;
						}
					}
				}
			}
		}
		if (max==0) { maxc=abs(poleY[max]-poleY[bod]); }
		if (min==0) { minc=abs(poleY[min]-poleY[bod]); }
		if (max>0) { 
			maxc=recurseV(max);
			if (maxc>0) { maxc+=abs(poleY[max]-poleY[bod]); }
		}
		if (min>0) { 
			minc=recurseV(min);
			if (minc>0) { minc+=abs(poleY[min]-poleY[bod]); }
		}
		if ((maxc>0)&&(minc>0)) {
			delkaH[bod]= maxc>minc ? maxc : minc;
		} else if (maxc>0) {
			delkaH[bod]=maxc;
		} else if (minc>0) {
			delkaH[bod]=minc;
		} else {
			delkaH[bod]=-2;
		}
	}
	return delkaH[bod];
}
int recurseV(int bod) {
	int i, max=-1, min=-1, maxc=-1, minc=-1;
	if (delkaV[bod]==-1) {
		for (i=0;i<n;i++) {
			if ((poleY[i]==poleY[bod])&&(i!=bod)) {
				if (poleX[i]<poleX[bod]) {
					if (min==-1) {
						min=i;
					} else {
						if (poleX[i]>poleX[min]) {
							min=i;
						}
					}
				} else {
					if (max==-1) {
						max=i;
					} else {
						if (poleX[i]<poleX[max]) {
							max=i;
						}
					}
				}
			}
		}
		if (max==0) { maxc=abs(poleX[max]-poleX[bod]); }
		if (min==0) { minc=abs(poleX[min]-poleX[bod]); }
		if (max>0) { 
			maxc=recurseH(max);
			if (maxc>0) { maxc+=abs(poleX[max]-poleX[bod]); }
		}
		if (min>0) { 
			minc=recurseH(min);
			if (minc>0) { minc+=abs(poleX[min]-poleX[bod]); }
		}
		if ((maxc>0)&&(minc>0)) {
			delkaV[bod]= maxc>minc ? maxc : minc;
		} else if (maxc>0) {
			delkaV[bod]=maxc;
		} else if (minc>0) {
			delkaV[bod]=minc;
		} else {
			delkaV[bod]=-2;
		}
	}
	return delkaV[bod];
}

int zpracuj() {
	int i, h, v;
	for (i=0;i<n;i++) {
		scanf("%d %d\n",&poleX[i],&poleY[i]);
		delkaV[i]=-1;
		delkaH[i]=-1;
	}
	h=recurseH(0);
	v=recurseV(0);
	return v<h ? h : v;
}

int main() {
	scanf("%d",&n);
	while(n) {
		printf("The length of the fence will be %d units.\n",zpracuj(n));
		scanf("%d",&n);
	}
	return 0;
}
